"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __decorateClass = (decorators, target, key, kind) => {
  var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target;
  for (var i = decorators.length - 1, decorator; i >= 0; i--)
    if (decorator = decorators[i])
      result = (kind ? decorator(target, key, result) : decorator(result)) || result;
  if (kind && result) __defProp(target, key, result);
  return result;
};

// src/index.ts
var src_exports = {};
__export(src_exports, {
  Pagination: () => Pagination
});
module.exports = __toCommonJS(src_exports);

// src/ui5-pagination-lit.ts
var import_lit = require("lit");
var import_decorators = require("lit/decorators.js");
var import_map = require("lit/directives/map.js");
var import_Button = require("@ui5/webcomponents/dist/Button.js");
var import_AllIcons = require("@ui5/webcomponents-icons/dist/AllIcons.js");
var Pagination = class extends import_lit.LitElement {
  constructor() {
    super(...arguments);
    this.pageIndex = 0;
    this.totalPage = 0;
    this.onClick = (e) => {
      return e;
    };
    this.prevIsDisabled = this.totalPage == 0 || this.pageIndex == 0;
    this.nextIsDisabled = this.totalPage == 0 || this.pageIndex == this.totalPage - 1;
  }
  _onClick(e) {
    if (e.target.tagName === "UI5-BUTTON") {
      this.onClick(parseInt(e.target.dataset.to) + 1);
      this.pageIndex = parseInt(e.target.dataset.to);
    }
  }
  render() {
    return import_lit.html`
      <span
        @click=${this._onClick}
      >
          <ui5-button
            design="Emphasized"
            icon="navigation-left-arrow"
            disabled=${this.prevIsDisabled}
            data-to=${this.pageIndex - 1}
        ></ui5-button>
        ${(0, import_map.map)(Array(this.totalPage), (_, i) => {
      if (i === this.pageIndex)
        return import_lit.html`
              <ui5-button design="Emphasized" disabled>
                ${i + 1}
              </ui5-button>
            `;
      if (Math.abs(i - this.pageIndex) < Math.max(5 - this.pageIndex, 6 - this.totalPage + this.pageIndex, 2) || i == 1 && this.pageIndex == 3 || i == this.totalPage - 2 && this.pageIndex == this.totalPage - 4)
        return import_lit.html`
            <ui5-button design="Default" data-to=${i}>
                ${i + 1}
            </ui5-button>`;
      if (i === 0)
        return import_lit.html`
                <ui5-button design="Default" data-to="0">
                    1
                </ui5-button>
            `;
      if (i === this.totalPage - 1)
        return import_lit.html`
                <ui5-button design="Default" data-to=${i}>
                    ${this.totalPage}
                </ui5-button>
            `;
      if (i === 1)
        return import_lit.html`
                  <ui5-button design="Transparent" disabled>
                      ...
                  </ui5-button>
              `;
      if (i === this.totalPage - 2)
        return import_lit.html`
                  <ui5-button design="Transparent" disabled>
                      ...
                  </ui5-button>
              `;
    })}
        <ui5-button
          design="Emphasized"
          icon="navigation-right-arrow"
          disabled=${this.nextIsDisabled}
          data-to=${this.pageIndex + 1}
        >
        </ui5-button>
      </span>
      `;
  }
};
__decorateClass([
  (0, import_decorators.property)({ type: Number })
], Pagination.prototype, "pageIndex", 2);
__decorateClass([
  (0, import_decorators.property)({ type: Number })
], Pagination.prototype, "totalPage", 2);
__decorateClass([
  (0, import_decorators.property)({ type: Function })
], Pagination.prototype, "onClick", 2);
__decorateClass([
  (0, import_decorators.state)({})
], Pagination.prototype, "prevIsDisabled", 2);
__decorateClass([
  (0, import_decorators.state)({})
], Pagination.prototype, "nextIsDisabled", 2);
Pagination = __decorateClass([
  (0, import_decorators.customElement)("ui5-pagination-lit")
], Pagination);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Pagination
});
